<template>
  <button
    class="button"
    v-bind:disabled="spinner"
    :style="{ gridColumnEnd: `span ${size}` }"
  >
    {{ text }}<slot />
    <font-awesome-icon
      class="icon"
      v-if="spinner"
      :icon="icons.faCircleNotch"
    />
  </button>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faCircleNotch } from "@fortawesome/free-solid-svg-icons";

@Options({
  props: {
    text: {
      type: String,
      default: "",
    },
    size: {
      type: String,
      default: "1",
    },
    spinner: {
      type: Boolean,
      default: false,
    },
  },
  components: {
    FontAwesomeIcon,
  },
})
export default class InputButton extends Vue {
  public text!: string;
  public size!: string;
  public spinner!: boolean;

  public icons = {
    faCircleNotch,
  };
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

.button {
  display: block;
  background-color: $dark_blue;
  color: white;

  padding: 15px;

  font-size: 16px;
  font-weight: bold;

  width: 100%;
  border: none;
  outline: none;
  cursor: pointer;

  text-decoration: none;

  box-shadow: 0 0 3px 0 $shadow_grey;
  box-sizing: border-box;

  &:hover {
    box-shadow: 0 0 0 3px $shadow_grey;
  }

  &:disabled {
    background-color: $grey_text;
  }

  .icon {
    @include spinner;

    margin: 0 0 -1px 3px;
  }
}
</style>
